<% . /usr/local/lib/cgi/haserl.sh ; check_instances pjsua_uihome.cgi %>
<% . /lib/config/functions.sh %>
<html>
<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<style type="text/css">
<!--
body,td,th {
  margin-left: 20px;
  font-family: Arial, Helvetica, sans-serif;
  font-size: 13px;
  font-weight: bold;
  color: #333333;
}
th.val,td.val {
  background-color: #e6e8eb;
  font-weight: normal;
}
th.wh,td.wh {
  background-color: #ffffff;
}
img.cmd {
  width: 0px;
  height: 0px;
  visibility: hidden;
}
-->
</style>

<script language=JavaScript>

var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
var isIE=0;

/*@cc_on
 @if (@_jscript_version == 10)
	isIE=10;
 @else
	// old way to go
	isIE=1;
 @end
@*/

var delay = 1000;
var xmlhttp=false;
var empty_cnt;

// get best/appropriate xmlhttprequest object
if (isIE) {
	try {
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
		try {
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (E) {
			xmlhttp = false;
		}
	}
} else {
	xmlhttp = false;
}
// now go with std (non IE) xmlhttp
if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	try {
		xmlhttp = new XMLHttpRequest();
	} catch (e) {
		xmlhttp = false;
	}
}

function send_xmlhttp_request (url, funct) {
	xmlhttp.open("GET", url, true);
	if (!isIE)
		xmlhttp.overrideMimeType('text/plain');
	xmlhttp.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
	if(!funct) funct = function(){};
	xmlhttp.onreadystatechange=funct;
	xmlhttp.send(null);
}

function gotStatus(data) {
	/* 
	 * not found http error <?xml  ?
	 */
	if (data.substr(0,2)=="<?") return;
	
	if (data!="") {
		processStatusData(data);
	}else{
		//did not get response, stop polling and report error 
		// stop sending requests
		// send_xmlhttp_request("/cgi-bin/sip.cgi?get_status=1",0);
	}
	setTimeout("getStatus()", delay);	
}

function getStatus() {
	if (xmlhttp) {
		function reply() {
			if (xmlhttp.readyState==4) {
				gotStatus(xmlhttp.responseText);
			}
		};
		send_xmlhttp_request("/cgi-bin/command.cgi?get_player_status=1",reply);
	}
}

function startStatusPolling() {
	empty_cnt=0;	
	setTimeout("getStatus()", delay);		
}

function processStatusData(statusData){
	var theReturnedVars=statusData.split(";");
	// provide fake status in case the device is not reachable
	var statusData='{"m_player_state":" ","m_curr_song_name":" ","m_playlist_name":" ","error":" "};'
	if (theReturnedVars[0] != "") statusData=JSON.parse(theReturnedVars[0]);
	var playerState=parseInt(statusData.m_player_state);
	
	if ( theReturnedVars[1] != "") {
		// we have PID, so the app is running

		switch (playerState) {
			case 0:
				playerState = "Idle";
				break;
			case 1:
				playerState = "Playing ...";
				break;
			case 2:
				playerState = "Paused";
				break;
			case 3:
				playerState = "Ending ...";
				break;
			case 4:
				playerState = "Connecting ...";
				break;
			case 5:
				playerState = "Buffering ...";
				break;
			case 6:
				playerState = "Waiting ...";
				break;
			case "":
			case "NaN":
				playerState = "Player unavailable";
				break;
			default:
				playerState = "Undefined state"+playerState;
				break;
		
		}
		document.getElementById('track_id').innerHTML=decodeURIComponent(statusData.m_curr_song_name);
		document.getElementById('playlist_name').innerHTML=statusData.m_playlist_name;
		document.getElementById('player_state').innerHTML=playerState;
	}else{
		document.getElementById('track_id').innerHTML="";
		document.getElementById('playlist_name').innerHTML="";
		document.getElementById('player_state').innerHTML="Player not running !";
	}
}

function sendSingleCommand(cmd){
   	var randomActNo=Math.floor(Math.random()*1001);
   	var dataHref="/cgi-bin/command.cgi?"+cmd+"&"+randomActNo;
   	document.images["senddataimg"].src = dataHref; // use fake img to send data without reloading
}

</script>
</head>
<body link=#000000 vlink=#000000 alink=#000000 onload="startStatusPolling();"><font face="Arial, Helvetica, sans-serif">
<img class="cmd" name="senddataimg" src="">

<table width=510px>
<col width="100px">
<col width="410px">
<tr>
<td colspan=2>BARIX SIMPLE PLAYER HOME PAGE</td>
</tr>
</table>
<br>
<table cellspacing="0" cellpadding="3" width="510px">
	<tr>
		<td colspan=2>
			Barix Simple Player Application Status
		</td>
	</tr>
	<tr>
		<td> Application Mode </td>
		<td class="val" id=player_mode><% if cfg_string_compare simple_player.common.media_type files ; then echo "MP3 File Player" ; else echo "Stream Player" ; fi %></td>
	</tr>
	<tr>
		<td> Player Status </td>
		<td class="val" id=player_state></td>
	</tr>
	<tr>
		<td> Track/Stream Name </td>
		<td class="val" id=track_id></id>
	</tr>
	<tr>
		<td> Playlist Name </td>
		<td class="val" id=playlist_name></id>
	</tr>	
</table>
<br>
<table cellspacing="0" cellpadding="3" width="510px">
	<tr>
		<td colspan=2>
			Barix Simple Player Command Buttons
		</td>
	</tr>
	<tr>
		<td>
			<input type=button value=Stop App onclick=sendSingleCommand('app_stop=1'); >
		</td>
		<td>
			<input type=button value=Start App onclick=sendSingleCommand('app_start=1');>
		</td>
		<td> 
		</td>
	</tr>
</table>



<br>

</body>
</html>
